require "cgi"
require "base64"
require "openssl"
class AzureSAS
  def self.get_token(uri,key_name,key_value,ttl=3600)
    t=(Time.now+ttl).to_i
    data=CGI.escape(uri)+"\n#{t}"
    c=CGI.escape(Base64.encode64(OpenSSL::HMAC.digest(OpenSSL::Digest::SHA256.new,key_value,data)).strip())
    puts "SharedAccessSignature sr=#{CGI.escape(uri)}&sig=#{c}&se=#{t}&skn=#{key_name}"
  end
end
